// CConv.c MEX file to perform convolution using Intel SPL
#include "mex.h"
#include <math.h>
#define nsp_UsesAll	// uses Intel library functions
#include "nsp.h"
/* this is a mex function specifically designed for use with reSynth.m */
/* error trapping is kept to a minimum to enhance speed */
void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
	double *in1,*in2,*convolved;
	int lengthIn1,lengthIn2,n1,n2,m2,m1;	//lengths of input vectors
	// variables passed from MATLAB
	in1 = mxGetPr(prhs[0]);
	in2 = mxGetPr(prhs[1]);
	n1 = mxGetN(prhs[0]);
	n2 = mxGetN(prhs[1]);
	m1 = mxGetM(prhs[0]);
	m2 = mxGetM(prhs[1]);
	if ((n1>1 && m1>1) || (n2>1 && m2>1))	mexErrMsgTxt("Error using CConv.\nInputs must be vectors.");
	// assume that vectors are rows rather than columns
	lengthIn1 = n1;
	lengthIn2 = n2;
	// but double check that they are not columns
	if (m1>n1) lengthIn1 = m1;
	if (m2>n2) lengthIn2 = m2;

	// allocate array for ouput
	plhs[0] = mxCreateDoubleMatrix(1,lengthIn1+lengthIn2-1,mxREAL);
	convolved = mxGetPr(plhs[0]);

	// do fast Intel convolution
	nspdConv(in1,lengthIn1,in2,lengthIn2,convolved);
	
}