// CFindPeaks.c MEX file to find magnitude peaks in amplitude array
#include "mex.h"
/* this is a mex function specifically designed for use with reSynth.m */
/* error trapping is kept to a minimum to enhance speed */
void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
	double sineIndex[1025];

	// get size of amplitude array
	double *temp,*amp;
	int complexSize,a,N,n,upper;
	temp = mxGetPr(prhs[1]);
	complexSize = (int)temp[0];
	upper = complexSize-5;
	N = mxGetN(prhs[0]);
	if(N!=complexSize)	{
		mexErrMsgTxt("size of array does not match reported size");
	}
	a = 0;

	// pass in amplitude array
	amp = mxGetPr(prhs[0]);
	
	for(n=4;n<upper;n++)	{
		if(amp[n]>amp[n-4]&&amp[n]>amp[n-3]&&amp[n]>amp[n-2]&&amp[n]>amp[n-1]&&
			amp[n]>amp[n+4]&&amp[n]>amp[n+3]&&amp[n]>amp[n+2]&&amp[n]>amp[n+1]){
				sineIndex[a] = (double)n+1;
				a++;
			}
	}
	// copy sineIndex into temporary array
	// and assign to output array
	plhs[0] = mxCreateDoubleMatrix(1,a,mxREAL);
	temp = mxGetPr(plhs[0]);
	for (n=0;n<a;n++)
		temp[n] = sineIndex[n];
}